//--------------------------------------------------------------------//
// LTCN

var canvas;				// LoXvf
var context;	 			// ReLXg
var cycle;				// LTCNf[^
var pvWindow,tsWindow;			// P-V }ET-S }
var infoX,infoY;			// eLXg`ʒu
var errMessage;				// G[bZ[W

var FG_COLOR='rgb(0,0,0)';		// OiF
var BG_COLOR='rgb(255,255,255)';	// wiF
var PV_COLOR1='rgb(204,0,0)';		// P-V}`F1
var PV_COLOR2='rgb(255,153,153)';	// P-V}`F2
var TS_COLOR1='rgb(0,0,204)';		// T-S}`F1
var TS_COLOR2='rgb(153,153,255)';	// T-S}`F2
var FONT_SIZE=14;			// tHgTCY
var SCALE_SIZE=4;			// ڐ`TCY
var P_MAX=50;				// ͍ől
var INC=30;				// `捏
var LOG10=Math.log(10);			// log10
// eLXg
/*
var TEXTS1=['Lower temparature ',
      	    'Heat flow to the system ',
      	    'Heat flow from the system ',
      	    'Work of pump ',
      	    'Work of turbine ',
      	    'Thermodynamic efficiency '];
*/
var TEXTS1=['ቷx ',
      	    '{C[ŉM ',
      	    'ŕMM ',
      	    '|vd ',
      	    '^[rd ',
      	    'M '];

// f[^
// fileName - C\f[^t@C
function initRankineCycle(fileName){
  cycle=new RankineCycle();
  errMessage='';
  initCanvas();
  readServerFile(fileName);
  draw();
}

// LoX
function initCanvas(){
  canvas=document.getElementById('rankinecycle');
  canvas.width=canvas.clientWidth;
  canvas.height=canvas.clientHeight;
  context=canvas.getContext('2d');
  context.strokeStyle=FG_COLOR;
  context.font=FONT_SIZE+"px 'Arial'";
  context.textBaseline='top';
  pvWindow=new GraphWindow('V[m3/kg]',true,'P[MPa]',false);
//  tsWindow=new GraphWindow('S[kJ/kgK]',false,'T[degC]',false);
  tsWindow=new GraphWindow('S[kJ/kgK]',false,'T[]',false);
  setBorders();
}

// `拫Eݒ肷
function setBorders(){
  var x=parseInt(0.1*canvas.width);
  var y=parseInt(0.1*canvas.height);
  var w=parseInt(0.35*canvas.width);
  var h=parseInt(0.4*canvas.height);
  pvWindow.setBorder(x,y,w,h);
  tsWindow.setBorder(parseInt(x+0.5*canvas.width),y,w,h);
  infoX=x;
  infoY=parseInt(y+0.5*canvas.height);
  pvWindow.setAxis();
  tsWindow.setAxis();
}

// WebT[o[̃t@Cǂݍ
// fileName - C\f[^t@C
function readServerFile(fileName){
  var xhr=new XMLHttpRequest();
  try{
    xhr.open('GET',fileName,false);
  }
  catch(e){
    alert(e);
  }
  xhr.onreadystatechange=function(){
    if((xhr.readyState===4) && ((xhr.status===0) || (xhr.status===200))){
      readSteamData(xhr.responseText.split(/\r?\n/g));
    }
  };
  xhr.send(null);
}

// C\f[^ǂݍ
// s - f[^̃Xg
function readSteamData(s){
  var row=0,count,i,j,m;
  var sv=cycle.table.saturatedVapor;
  var hv=cycle.table.heatedVapor;
  var cw=cycle.table.compressedWater;
  while(row<s.length){
    var ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
    if(ss.length>=2){
      var keyWord=ss[0].toLowerCase();
      if(keyWord=='saturatedvapor'){
      	count=parseInt(ss[1]);
      	sv.setCount(count);
      	for(i=0;i<count;i++){
      	  row++;
      	  ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
      	  sv.setParameter(i,Number(ss[0]),Number(ss[1]),
      	      	      	  getVariable(2,ss),getVariable(6,ss));
      	}
      }
      else if(keyWord=='superheatedvapor'){
      	count=parseInt(ss[1]);
      	hv.setPressCount(count);
      	for(i=0;i<count;i++){
      	  row++;
      	  ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
      	  m=parseInt(ss[1]);
      	  hv.setPressData(i,Number(ss[0]),m);
      	  for(j=0;j<m;j++){
      	    row++;
      	    ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
      	    hv.setParameter(i,j,Number(ss[0]),getVariable(1,ss));
      	  }
      	}
      }
      else if(keyWord=='compressedwater'){
      	count=parseInt(ss[1]);
      	cw.setPressCount(count);
      	for(i=0;i<count;i++){
      	  row++;
      	  ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
      	  m=parseInt(ss[1]);
      	  cw.setPressData(i,Number(ss[0]),m);
      	  for(j=0;j<m;j++){
      	    row++;
      	    ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
      	    cw.setParameter(i,j,Number(ss[0]),getVariable(1,ss));
      	  }
      	}
      }
    }
    row++;
  }
}

// Cp[^ǂݍ
// i - JnCfbNX
// ss - f[^z
function getVariable(i,ss){
  return new VaporVariable(Number(ss[i]),Number(ss[i+1]),
      	      	      	   Number(ss[i+2]),Number(ss[i+3]));
}

// `f[^ݒ肷
function setDrawData(){
  pvWindow.setData(cycle.getSaturatedPV(),cycle.getPV());
  tsWindow.setData(cycle.getSaturatedTS(),cycle.getTS());
  pvWindow.setAxis();
  tsWindow.setAxis();
}

// `悷
function draw(){
  context.fillStyle=BG_COLOR;
  context.fillRect(0,0,canvas.width,canvas.height);
  context.fillStyle=FG_COLOR;
  if(errMessage===''){
    pvWindow.draw(PV_COLOR1,PV_COLOR2);
    tsWindow.draw(TS_COLOR1,TS_COLOR2);
    drawInfo();
  }
  else{
    var metrix=context.measureText(errMessage);
    var x=parseInt((canvas.width-metrix.width)/2);
    context.fillText(errMessage,x,2*FONT_SIZE);
  }
}

// eLXg`悷
function drawInfo(){
  if(cycle.sv1===undefined) return;
  var texts2=['T1: '+cycle.sv1.t.toFixed(4)+' [degC]',
      	      'Q1: '+cycle.q1.toFixed(4)+' [kJ/kg]',
      	      'Q2: '+cycle.q2.toFixed(4)+' [kJ/kg]',
      	      'Wp: '+cycle.wp.toFixed(4)+' [kJ/kg]',
      	      'Wt: '+cycle.wt.toFixed(4)+' [kJ/kg]',
      	      'Eta: '+cycle.efficiency.toFixed(5)];
  var w1=0,w2=0;
  for(var i=0;i<6;i++){
    var metrix=context.measureText(TEXTS1[i]);
    w1=Math.max(w1,metrix.width);
    metrix=context.measureText(texts2[i]);
    w2=Math.max(w2,metrix.width);
  }
  for(i=0;i<6;i++){
    context.fillText(TEXTS1[i],infoX,infoY+FONT_SIZE*i);
    context.fillText(texts2[i],infoX+w1,infoY+FONT_SIZE*i);
  }
  context.strokeRect(infoX-2,infoY-2,w1+w2+4,6*FONT_SIZE+4);
}

// `悷
function drawDiagram(){
  try{
    var p1=Number(document.getElementById('p1').value);
    var p2=Number(document.getElementById('p2').value);
    var t3=Number(document.getElementById('t3').value);
    cycle.setCondition(p1,p2,t3);
    cycle.createDiagram();
    setDrawData();
    errMessage='';
  }
  catch(e){
    errMessage='Error: '+e.message;
  }
  draw();
}

// ԗʃf[^쐬
// t,p - xE
// vv - Cp[^
function createState(t,p,vv){
  return new StateVariable(t,p,vv.v,vv.u,vv.h,vv.s);
}

// f[^YCfbNX
// low,high - CfbNX̉E
// v - f[^̒l
// array - f[^z
function serachIndex(low,high,v,array){
  var mid;
  if(array[low]<array[high]){
    do{
      mid=parseInt((low+high)/2);
      if(array[mid]<=v)     low=mid+1;
      else if(array[mid]>v) high=mid;
    }while(low<high);
  }
  else{
    do{
      mid=parseInt((low+high)/2);
      if(array[mid]>=v)     low=mid+1;
      else if(array[mid]<v) high=mid;
    }while(low<high);
  }
  return (low+high)/2-1;
}

// f[^YCfbNX
// low,high - CfbNX̉E
// v - f[^̒l
// vv - f[^z
function serachIndexS(low,high,v,vv){
  var mid;
  if(vv[low].s<vv[high].s){
    do{
      mid=parseInt((low+high)/2);
      if(vv[mid].s<=v)     low=mid+1;
      else if(vv[mid].s>v) high=mid;
    }while(low<high);
  }
  else{
    do{
      mid=parseInt((low+high)/2);
      if(vv[mid].s>=v)     low=mid+1;
      else if(vv[mid].s<v) high=mid;
    }while(low<high);
  }
  return (low+high)/2-1;
}

// pNX쐬
// ctor - VNX
// superCtor - pNX
function inherits(ctor,superCtor){
  if((ctor===undefined) || (ctor===null))
    throw new TypeError('The constructor to `inherits` must not be '+
                        'null or undefined.');

  if((superCtor===undefined) || (superCtor===null))
    throw new TypeError('The super constructor to `inherits` must '+
                        'not be null or undefined.');

  if(superCtor.prototype===undefined)
    throw new TypeError('The super constructor to `inherits` must '+
                        'have a prototype.');
  ctor.super_=superCtor;
  Object.setPrototypeOf(ctor.prototype,superCtor.prototype);
}

//--------------------------------------------------------------------//
// LTCNf[^
var RankineCycle=function(){
  this.table=new SteamTable();	// C\
  this.p1=0;			// ሳ
  this.p2=0;			// 
  this.t3=0;			// ^[rCx
  this.wt=0;			// ^[rd
  this.wp=0;			// |vd
  this.q1=0;			// {C[ŉM
  this.q2=0;			// ŕMM
  this.efficiency=0;		// M
  this.pv=[];			// P-V }̓_
  this.ts=[];			// T-S }̓_
};

// TCNݒ肷
// p1,p2 - ሳE
// t3 - ^[rCx
RankineCycle.prototype.setCondition=function(p1,p2,t3){
  var sv=this.table.saturatedVapor;
  if(p1>=p2){
//    throw new Error('P1>=P2');
    throw new Error('ሳȉ̈͂ł');
  }
  else if(p1<=sv.getTripleP()){
//    throw new Error('P1<=Triple point');
    throw new Error('ሳ͂Od_ȉł');
  }
  else if(p1>=sv.getCriticalP()){
//    throw new Error('P1>=Critical point');
    throw new Error('ሳ͂ՊE͈ȏł');
  }
  else if(p2>P_MAX){
//    throw new Error('P2>Limit pressure');
    throw new Error('͂f[^͈͂𒴂Ă܂');
  }
  else if(t3<=sv.getGasByP(p2).t){
//    throw new Error('T3<=Saturated point');
    throw new Error('CxOaC_ȉł');
  }
  this.p1=p1;
  this.p2=p2;
  this.t3=t3;
};

// }f[^𒊏o
RankineCycle.prototype.createDiagram=function(){
  this.pv.length=0;
  this.ts.length=0;
  var sv=this.table.saturatedVapor;
  var hv=this.table.heatedVapor;
  var cw=this.table.compressedWater;
  this.sv1=sv.getLiquidByP(this.p1);
  this.addPoint(this.sv1);
  this.sv2=cw.getByPS(this.p2,this.sv1.s);
  this.addPoint(this.sv2);
// QR
  var t21=sv.getCriticalT(),i,ds,dt;
  if(this.p2<sv.getCriticalP()){
    var sv21=sv.getLiquidByP(this.p2);
    ds=(sv21.s-this.sv1.s)/INC;
    for(i=1;i<INC;i++){
      this.addPoint(cw.getByPS(this.p2,this.sv1.s+ds*i));
    }
    this.addPoint(sv21);
    var sv22=sv.getGasByP(this.p2);
    this.addPoint(sv22);
    t21=sv22.t;
  }
  else{
    dt=(t21-this.sv2.t)/INC;
    for(i=1;i<=INC;i++){
      this.addPoint(cw.getByPT(this.p2,this.sv2.t+dt*i));
    }
  }
  dt=(this.t3-t21)/INC;
  for(i=1;i<INC;i++){
    this.addPoint(hv.getByPT(this.p2,t21+dt*i));
  }
  this.sv3=hv.getByPT(this.p2,this.t3);
  this.addPoint(this.sv3);
// RS
  var sv31=sv.getGasByS(this.sv3.s),dp,sr;
  if(sv31.t>=this.sv1.t){
    dp=(sv31.p-this.p2)/INC;
    for(i=1;i<=INC;i++){
      this.addPoint(hv.getByPS(this.p2+dp*i,this.sv3.s));
    }
    this.addPoint(sv31);
    dp=(this.p1-sv31.p)/INC;
    for(i=1;i<INC;i++){
      var sv32=sv.getGasByP(sv31.p+dp*i);
      sr=(this.sv3.s-this.sv1.s)/(sv32.s-this.sv1.s);
      this.pv.push(new Point(this.sv1.v+sr*(sv32.v-this.sv1.v),sv32.p));
      this.ts.push(new Point(this.sv3.s,sv32.t));
    }
    this.sv4=sv.getGasByP(this.p1);
    sr=(this.sv3.s-this.sv1.s)/(this.sv4.s-this.sv1.s);
    this.sv4.p=this.p1;
    this.sv4.v=this.sv1.v+sr*(this.sv4.v-this.sv1.v);
    this.sv4.u=this.sv1.u+sr*(this.sv4.u-this.sv1.u);
    this.sv4.h=this.sv1.h+sr*(this.sv4.h-this.sv1.h);
    this.sv4.s=this.sv3.s;
    this.addPoint(this.sv4);
  }
  else{
    dp=(this.p1-this.p2)/INC;
    for(i=1;i<INC;i++){
      this.addPoint(hv.getByPS(this.p2+dp*i,this.sv3.s));
    }
    this.sv4=hv.getByPS(this.p1,this.sv3.s);
    this.addPoint(this.sv4);
    var sv41=sv.getGasByP(this.p1);
    ds=(sv41.s-this.sv4.s)/INC;
    for(i=1;i<INC;i++){
      this.addPoint(hv.getByPS(this.p1,this.sv4.s+ds*i));
    }
    this.addPoint(sv41);
  }
  this.wp=this.sv2.h-this.sv1.h;
  this.wt=this.sv3.h-this.sv4.h;
  this.q1=this.sv3.h-this.sv2.h;
  this.q2=this.sv4.h-this.sv1.h;
  this.efficiency=(this.wt-this.wp)/this.q1;
};

// f[^_ǉ
// sv - ԗ
RankineCycle.prototype.addPoint=function(sv){
  this.pv.push(new Point(sv.v,sv.p));
  this.ts.push(new Point(sv.s,sv.t));
};

// P-V }̖Oatf[^Ԃ
RankineCycle.prototype.getLiquidPV=function(){
  return this.table.saturatedVapor.getLiquidPV();
};

// T-S }̖Oatf[^Ԃ
RankineCycle.prototype.getLiquidTS=function(){
  return this.table.saturatedVapor.getLiquidTS();
};

// P-V }̖OaCf[^Ԃ
RankineCycle.prototype.getGasPV=function(){
  return this.table.saturatedVapor.getGasPV();
};

// T-S }̖OaCf[^Ԃ
RankineCycle.prototype.getGasTS=function(){
  return this.table.saturatedVapor.getGasTS();
};

// P-V }̖OatECf[^Ԃ
RankineCycle.prototype.getSaturatedPV=function(){
  var p1=this.table.saturatedVapor.getLiquidPV();
  var p2=this.table.saturatedVapor.getGasPV();
  var p=[];
  for(var i=0;i<p1.length;i++){
    p[i]=p1[i].clone();
    p[p1.length-1+i]=p2[i].clone();
  }
  return p;
};

// T-S }̖OatECf[^Ԃ
RankineCycle.prototype.getSaturatedTS=function(){
  var p1=this.table.saturatedVapor.getLiquidTS();
  var p2=this.table.saturatedVapor.getGasTS();
  var p=[];
  for(var i=0;i<p1.length;i++){
    p[i]=p1[i].clone();
    p[p1.length-1+i]=p2[i].clone();
  }
  return p;
};

// P-V }f[^Ԃ
RankineCycle.prototype.getPV=function(){
  var p=[];
  for(var i=0;i<this.pv.length;i++) p[i]=this.pv[i].clone();
  return p;
};

// T-S }f[^Ԃ
RankineCycle.prototype.getTS=function(){
  var p=[];
  for(var i=0;i<this.ts.length;i++) p[i]=this.ts[i].clone();
  return p;
};

//--------------------------------------------------------------------//
// C\
var SteamTable=function(){
  this.saturatedVapor=new SaturatedVapor();	// OaCf[^
  this.heatedVapor=new SteamTableData();	// MCf[^
  this.compressedWater=new SteamTableData();	// kf[^
};

//--------------------------------------------------------------------//
// OaCf[^
var SaturatedVapor=function(){
  this.count=0;	// f[^
  this.t=[];	// x
  this.p=[];	// 
  this.vvf=[];	// t̑p[^
  this.vvg=[];	// Cp[^
};

// f[^ݒ肷
// count - f[^
SaturatedVapor.prototype.setCount=function(count){
  this.count=count;
};

// f[^ݒ肷
// index - f[^̃CfbNX
// t,p,vvf,vvg - xÉEt̑p[^ECp[^
SaturatedVapor.prototype.setParameter=function(index,t,p,vvf,vvg){
  this.t[index]=t;
  this.p[index]=p;
  this.vvf[index]=vvf;
  this.vvg[index]=vvg;
};

// P-V }̖Oatf[^Ԃ
SaturatedVapor.prototype.getLiquidPV=function(){
  var pt=[],len=this.p.length;
  for(var i=0;i<len;i++){
    pt[i]=new Point(this.vvf[i].v,this.p[i]);
  }
  return pt;
};

// T-S }̖Oatf[^Ԃ
SaturatedVapor.prototype.getLiquidTS=function(){
  var pt=[],len=this.t.length;
  for(var i=0;i<len;i++){
    pt[i]=new Point(this.vvf[i].s,this.t[i]);
  }
  return pt;
};

// P-V }̖OaCf[^Ԃ
SaturatedVapor.prototype.getGasPV=function(){
  var pt=[],len=this.p.length;
  for(var i=0;i<len;i++){
    pt[len-1-i]=new Point(this.vvg[i].v,this.p[i]);
  }
  return pt;
};

// T-S }̖OaCf[^Ԃ
SaturatedVapor.prototype.getGasTS=function(){
  var pt=[],len=this.t.length;
  for(var i=0;i<len;i++){
    pt[len-1-i]=new Point(this.vvg[i].s,this.t[i]);
  }
  return pt;
};

// Od_̈͂Ԃ
SaturatedVapor.prototype.getTripleP=function(){
  return this.p[0];
};

// Od_̉xԂ
SaturatedVapor.prototype.getTripleT=function(){
  return this.t[0];
};

// ՊE͂Ԃ
SaturatedVapor.prototype.getCriticalP=function(){
  return this.p[this.p.length-1];
};

// ՊExԂ
SaturatedVapor.prototype.getCriticalT=function(){
  return this.t[this.t.length-1];
};

// ͂ɑΉOatf[^Ԃ
// pp - 
SaturatedVapor.prototype.getLiquidByP=function(pp){
  var end=this.p.length-1;
  if(pp<=this.p[0]){
    return createState(this.t[0],pp,this.vvf[0]);
  }
  else if(pp>=this.p[end]){
    return createState(this.t[end],pp,this.vvf[end]);
  }
  else{
    var i=serachIndex(0,end,pp,this.p);
    var cc=(pp-this.p[i])/(this.p[i+1]-this.p[i]);
    return new StateVariable
      (this.t[i]+cc*(this.t[i+1]-this.t[i]),pp,
       this.vvf[i].v+cc*(this.vvf[i+1].v-this.vvf[i].v),
       this.vvg[i].u+cc*(this.vvg[i+1].u-this.vvg[i].u),
       this.vvf[i].h+cc*(this.vvf[i+1].h-this.vvf[i].h),
       this.vvf[i].s+cc*(this.vvf[i+1].s-this.vvf[i].s));
  }
};

// ͂ɑΉOaCf[^Ԃ
// pp - 
SaturatedVapor.prototype.getGasByP=function(pp){
  var end=this.p.length-1;
  if(pp<=this.p[0]){
    return createState(this.t[0],pp,this.vvg[0]);
  }
  else if(pp>=this.p[end]){
    return createState(this.t[end],pp,this.vvg[end]);
  }
  else{
    var i=serachIndex(0,end,pp,this.p);
    var cc=(pp-this.p[i])/(this.p[i+1]-this.p[i]);
    return new StateVariable
      (this.t[i]+cc*(this.t[i+1]-this.t[i]),pp,
       this.vvg[i].v+cc*(this.vvg[i+1].v-this.vvg[i].v),
       this.vvg[i].u+cc*(this.vvg[i+1].u-this.vvg[i].u),
       this.vvg[i].h+cc*(this.vvg[i+1].h-this.vvg[i].h),
       this.vvg[i].s+cc*(this.vvg[i+1].s-this.vvg[i].s));
  }
};

// Ggs[ɑΉOaCf[^Ԃ
// ss - Ggs[
SaturatedVapor.prototype.getGasByS=function(ss){
  var end=this.vvg.length-1;
  if(ss>=this.vvg[0].s){
    return createState(this.t[0],this.p[0],this.vvg[0]);
  }
  else if(ss<=this.vvg[end].s){
    return createState(this.t[end],this.p[end],this.vvg[end]);
  }
  else{
    var i=serachIndexS(0,end,ss,this.vvg);
    var cc=(ss-this.vvg[i].s)/(this.vvg[i+1].s-this.vvg[i].s);
    return new StateVariable
      (this.t[i]+cc*(this.t[i+1]-this.t[i]),
       this.p[i]+cc*(this.p[i+1]-this.p[i]),
       this.vvg[i].v+cc*(this.vvg[i+1].v-this.vvg[i].v),
       this.vvg[i].u+cc*(this.vvg[i+1].u-this.vvg[i].u),
       this.vvg[i].h+cc*(this.vvg[i+1].h-this.vvg[i].h),ss);
  }
};

//--------------------------------------------------------------------//
// \f[^
var SteamTableData=function(){
  this.pcount=0;	// ̓f[^
  this.p=[];		// 
  this.data=[];		// ͖̃f[^
};

// ̓f[^ݒ肷
// pcount - ̓f[^
SteamTableData.prototype.setPressCount=function(pcount){
  this.pcount=pcount;
  for(var i=0;i<pcount;i++){
    this.data[i]=new PressureTable();
  }
};

// ̓f[^ݒ肷
// index - ͂̃CfbNX
// p - 
// count - xf[^
SteamTableData.prototype.setPressData=function(index,p,count){
  this.p[index]=p;
  this.data[index].setCount(count);
};

// f[^ݒ肷
// index1 - ͂̃CfbNX
// index2 - xf[^̃CfbNX
// t - x
// vp - p[^
SteamTableData.prototype.setParameter=function(index1,index2,t,vp){
  this.data[index1].setParameter(index2,t,vp);
};

// ́ExɑΉf[^Ԃ
// pp,tt - ́Ex
SteamTableData.prototype.getByPT=function(pp,tt){
  var end=this.p.length-1,sv3;
  if(pp<=this.p[0]){
    return this.data[0].getByT(pp,tt);
  }
  else if(pp>=this.p[end]){
    return this.data[end].getByT(pp,tt);
  }
  else{
    var i=serachIndex(0,end,pp,this.p);
    var cc=(pp-this.p[i])/(this.p[i+1]-this.p[i]);
    var sv1=this.data[i].getByT(pp,tt);
    var sv2=this.data[i+1].getByT(pp,tt);
    if(this.data[i].isOverT(tt)){
      sv3=this.data[i+1].getByT(pp,(tt+(cc-1.0)*sv1.t)/cc);
      return new StateVariable(tt,pp,sv1.v+cc*(sv3.v-sv1.v),
      	      	      	       sv1.u+cc*(sv3.u-sv1.u),
      	      	      	       sv1.h+cc*(sv3.h-sv1.h),
      	      	      	       sv1.s+cc*(sv3.s-sv1.s));
    }
    else if(this.data[i+1].isOverT(tt)){
      sv3=this.data[i].getByT(pp,(tt-cc*sv2.t)/(1.0-cc));
      return new StateVariable(tt,pp,sv3.v+cc*(sv2.v-sv3.v),
      	      	      	       sv3.u+cc*(sv2.u-sv3.u),
      	      	      	       sv3.h+cc*(sv2.h-sv3.h),
      	      	      	       sv3.s+cc*(sv2.s-sv3.s));
    }
    else{
      return new StateVariable(tt,pp,sv1.v+cc*(sv2.v-sv1.v),
      	      	      	       sv1.u+cc*(sv2.u-sv1.u),
      	      	      	       sv1.h+cc*(sv2.h-sv1.h),
      	      	      	       sv1.s+cc*(sv2.s-sv1.s));
    }
  }
};

// ́EGgs[ɑΉf[^Ԃ
// pp,ss - ́EGgs[
SteamTableData.prototype.getByPS=function(pp,ss){
  var end=this.p.length-1,sv3;
  if(pp<=this.p[0]){
    return this.data[0].getByS(pp,ss);
  }
  else if(pp>=this.p[end]){
    return this.data[end].getByS(pp,ss);
  }
  else{
    var i=serachIndex(0,end,pp,this.p);
    var cc=(pp-this.p[i])/(this.p[i+1]-this.p[i]);
    var sv1=this.data[i].getByS(pp,ss);
    var sv2=this.data[i+1].getByS(pp,ss);
    if(this.data[i].isOverS(ss)){
      sv3=this.data[i+1].getByS(pp,(ss+(cc-1.0)*sv1.s)/cc);
      return new StateVariable(sv1.t+cc*(sv3.t-sv1.t),pp,
      	      	      	       sv1.v+cc*(sv3.v-sv1.v),
      	      	      	       sv1.u+cc*(sv3.u-sv1.u),
      	      	      	       sv1.h+cc*(sv3.h-sv1.h),ss);
    }
    else if(this.data[i+1].isOverS(ss)){
      sv3=this.data[i].getByS(pp,(ss-cc*sv2.s)/(1.0-cc));
      return new StateVariable(sv3.t+cc*(sv2.t-sv3.t),pp,
      	      	      	       sv3.v+cc*(sv2.v-sv3.v),
      	      	      	       sv3.u+cc*(sv2.u-sv3.u),
      	      	      	       sv3.h+cc*(sv2.h-sv3.h),ss);
    }
    else{
      return new StateVariable(sv1.t+cc*(sv2.t-sv1.t),pp,
      	      	      	       sv1.v+cc*(sv2.v-sv1.v),
      	      	      	       sv1.u+cc*(sv2.u-sv1.u),
      	      	      	       sv1.h+cc*(sv2.h-sv1.h),ss);
    }
  }
};

//--------------------------------------------------------------------//
// ̓f[^
var PressureTable=function(){
  this.count=0;	// f[^
  this.t=[];		// x
  this.vv=[];		// Cp[^
};

// f[^ݒ肷
// count - f[^
PressureTable.prototype.setCount=function(count){
  this.count=count;
};

// f[^ݒ肷
// index - f[^̃CfbNX
// t - x
// vv - p[^
PressureTable.prototype.setParameter=function(index,t,vv){
  this.t[index]=t;
  this.vv[index]=vv;
};

// xf[^͈͂𒴂Ăꍇ true
// tt - x
PressureTable.prototype.isOverT=function(tt){
  if(this.t[0]<this.t[this.count-1]){
    return ((tt<this.t[0]) || (this.t[this.count-1]<tt));
  }
  else{
    return ((tt>this.t[0]) || (this.t[this.count-1]>tt));
  }
};

// Ggs[f[^͈͂𒴂Ăꍇ true
// ss - Ggs[
PressureTable.prototype.isOverS=function(ss){
  if(this.vv[0].s<this.vv[this.count-1].s){
    return ((ss<this.vv[0].s) || (this.vv[this.count-1].s<ss));
  }
  else{
    return ((ss>this.vv[0].s) || (this.vv[this.count-1].s>ss));
  }
};

// xɑΉf[^Ԃ
// pp,tt - ́Ex
PressureTable.prototype.getByT=function(pp,tt){
  var end=this.t.length-1;
  if(this.t[0]<this.t[end]){
    if(tt<=this.t[0]){
      return createState(this.t[0],pp,this.vv[0]);
    }
    else if(tt>=this.t[end]){
      return createState(this.t[end],pp,this.vv[end]);
    }
  }
  else{
    if(tt>=this.t[0]){
      return createState(this.t[0],pp,this.vv[0]);
    }
    else if(tt<=this.t[end]){
      return createState(this.t[end],pp,this.vv[end]);
    }
  }
  var i=serachIndex(0,end,tt,this.t);
  var cc=(tt-this.t[i])/(this.t[i+1]-this.t[i]);
  return new StateVariable
    (tt,pp,this.vv[i].v+cc*(this.vv[i+1].v-this.vv[i].v),
     this.vv[i].u+cc*(this.vv[i+1].u-this.vv[i].u),
     this.vv[i].h+cc*(this.vv[i+1].h-this.vv[i].h),
     this.vv[i].s+cc*(this.vv[i+1].s-this.vv[i].s));
};

// Ggs[ɑΉf[^Ԃ
// pp,ss - ́EGgs[
PressureTable.prototype.getByS=function(pp,ss){
  var end=this.t.length-1;
  if(this.vv[0].s<this.vv[end].s){
    if(ss<=this.vv[0].s){
      return createState(this.t[0],pp,this.vv[0]);
    }
    else if(ss>=this.vv[end].s){
      return createState(this.t[end],pp,this.vv[end]);
    }
  }
  else{
    if(ss>=this.vv[0].s){
      return createState(this.t[0],pp,this.vv[0]);
    }
    else if(ss<=this.vv[end].s){
      return createState(this.t[end],pp,this.vv[end]);
    }
  }
  var i=serachIndexS(0,end,ss,this.vv);
  var cc=(ss-this.vv[i].s)/(this.vv[i+1].s-this.vv[i].s);
  return new StateVariable
    (this.t[i]+cc*(this.t[i+1]-this.t[i]),pp,
     this.vv[i].v+cc*(this.vv[i+1].v-this.vv[i].v),
     this.vv[i].u+cc*(this.vv[i+1].u-this.vv[i].u),
     this.vv[i].h+cc*(this.vv[i+1].h-this.vv[i].h),ss);
};

//--------------------------------------------------------------------//
// Cp[^
// v,u,h,s - eρEGlM[EG^s[EGgs[
var VaporVariable=function(v,u,h,s){
  this.v=v;
  this.u=u;
  this.h=h;
  this.s=s;
};

//--------------------------------------------------------------------//
// ԗ
// t,p - xE
// v,u,h,s - eρEGlM[EG^s[EGgs[
var StateVariable=function(t,p,v,u,h,s){
  VaporVariable.call(this,v,u,h,s);
  this.t=t;
  this.p=p;
};

//--------------------------------------------------------------------//
// _
// x,y - x,yW
var Point=function(x,y){
  this.x=x;
  this.y=y;
};

// _̃Rs[Ԃ
Point.prototype.clone=function(){
  return new this.constructor(this.x,this.y);
};

//--------------------------------------------------------------------//
// Ot
// xLabel - xx
// xIsLog - xΐƂꍇ true
// yLabel - yx
// yIsLog - yΐƂꍇ true
var GraphWindow=function(xLabel,xIsLog,yLabel,yIsLog){
  this.x=0;		// `̈
  this.y=0;
  this.width=0;
  this.height=0;
  if(xIsLog){		// x
    this.xAxis=new LogAxis(xLabel);
  }
  else{
    this.xAxis=new GraphAxis(xLabel);
  }
  if(yIsLog){		// y
    this.yAxis=new LogAxis(yLabel);
  }
  else{
    this.yAxis=new GraphAxis(yLabel);
  }
  this.p1=[];		// OaC}̓_f[^
  this.p2=[];		// TCN̓_f[^
};

// Eݒ肷
// x,y,width,height - \ʒuAA
GraphWindow.prototype.setBorder=function(x,y,width,height){
  this.x=x;
  this.y=y;
  this.width=width;
  this.height=height;
};

// f[^ݒ肷
// p1 - OaC}̓_f[^
// p2 - TCN̓_f[^
GraphWindow.prototype.setData=function(p1,p2){
  this.p1=p1;
  this.p2=p2;
};

// f[^ݒ肷
GraphWindow.prototype.setAxis=function(){
  var len=this.p2.length;
  if(len>0){
    var large=Number.MAX_VALUE;
    var xMin=large;
    var xMax=-large;
    var yMin=large;
    var yMax=-large;
    for(var i=0;i<len;i++){
      xMin=Math.min(xMin,this.p2[i].x);
      xMax=Math.max(xMax,this.p2[i].x);
      yMin=Math.min(yMin,this.p2[i].y);
      yMax=Math.max(yMax,this.p2[i].y);
    }
    this.xAxis.setScale(xMin,xMax);
    this.yAxis.setScale(yMin,yMax);
  }
  this.xAxis.setCoef(this.x,this.width,1);
  this.yAxis.setCoef(this.y+this.height,this.height,-1);
};

// Ot`悷
// color1,color2 - Ot\F
GraphWindow.prototype.draw=function(color1,color2){
  context.strokeStyle=color2;
  this.drawData(this.p1,false);
  context.strokeStyle=color1;
  this.drawData(this.p2,true);
  context.strokeStyle=FG_COLOR;
  this.drawBorder();
};

// Otf[^`悷
// p - _f[^
// closed - OtĂꍇ true
GraphWindow.prototype.drawData=function(p,closed){
  var len=p.length;
  if(len===0) return;
  if(closed) len++;
  context.beginPath();
  var x1=this.xAxis.toView(p[0].x);
  var y1=this.yAxis.toView(p[0].y);
  var contain1=((this.x<=x1) && (x1<=this.x+this.width)
      	     && (this.y<=y1) && (y1<=this.y+this.height));
  for(var i=1;i<len;i++){
    var ii=i%p.length;
    var x2=this.xAxis.toView(p[ii].x);
    var y2=this.yAxis.toView(p[ii].y);
    var contain2=((this.x<=x2) && (x2<=this.x+this.width)
      	       && (this.y<=y2) && (y2<=this.y+this.height));
    if(contain1 && contain2){
      context.moveTo(x1,y1);
      context.lineTo(x2,y2);
    }
    else if(contain1){
      this.drawLineBorders(x1,y1,x2,y2);
    }
    else if(contain2){
      this.drawLineBorders(x2,y2,x1,y1);
    }
    x1=x2;
    y1=y2;
    contain1=contain2;
  }
  context.closePath();
  context.stroke();
};

// gׂOt`悷
// x1,y1 - ̈̓_x,yW
// x2,y2 - ̈O̓_x,yW
GraphWindow.prototype.drawLineBorders=function(x1,y1,x2,y2){
  var xx,yy;
  if(x2<this.x){
    yy=(y2-y1)*(this.x-x1)/(x2-x1)+y1;
    if(yy<this.y){
      xx=(x2-x1)*(this.y-y1)/(y2-y1)+x1;
      context.moveTo(x1,y1);
      context.lineTo(xx,this.y);
    }
    else if(yy>this.y+this.height){
      xx=(x2-x1)*(this.y+this.height-y1)/(y2-y1)+x1;
      context.moveTo(x1,y1);
      context.lineTo(xx,this.y+this.height);
    }
    else{
      context.moveTo(x1,y1);
      context.lineTo(this.x,yy);
    }
  }
  else if(x2>this.x+this.width){
    yy=(y2-y1)*(this.x+this.width-x1)/(x2-x1)+y1;
    if(yy<this.y){
      xx=(x2-x1)*(this.y-y1)/(y2-y1)+x1;
      context.moveTo(x1,y1);
      context.lineTo(xx,this.y);
    }
    else if(yy>this.y+this.height){
      xx=(x2-x1)*(this.y+this.height-y1)/(y2-y1)+x1;
      context.moveTo(x1,y1);
      context.lineTo(xx,this.y+this.height);
    }
    else{
      context.moveTo(x1,y1);
      context.lineTo(this.x+this.width,yy);
    }
  }
  else if(y2<this.y){
    xx=(x2-x1)*(this.y-y1)/(y2-y1)+x1;
    context.moveTo(x1,y1);
    context.lineTo(xx,this.y);
  }
  else if(y2>this.y+this.height){
    xx=(x2-x1)*(this.y+this.height-y1)/(y2-y1)+x1;
    context.moveTo(x1,y1);
    context.lineTo(xx,this.y+this.height);
  }
};

// Otg`悷
GraphWindow.prototype.drawBorder=function(){
  context.strokeRect(this.x,this.y,this.width,this.height);
  this.xAxis.drawHorizontal(this.x,this.y+this.height,this.width);
  this.yAxis.drawVertical(this.x,this.y,this.height);
};

//--------------------------------------------------------------------//
// Ot
// text - x
var GraphAxis=function(text){
  this.text=text;
  this.scaleMin=0;	// ͈͍ŏl
  this.scaleMax=1;	// ͈͍ől
  this.scale=1;		// ڐ
  this.coef1=1;		// f[^|`ʒuϊW
  this.coef0=0;
  this.scaleLabel=[];	// ڐlx
  this.setScaleLabel();
};

// Otڐݒ肷
// minValue,maxValue - f[^ŏlEől
GraphAxis.prototype.setScale=function(minValue,maxValue){
  if(minValue>=maxValue){
    this.scaleMin=maxValue;
    this.scaleMax=this.scaleMin+1;
    this.scale=1;
  }
  else{
    var xm=Math.max(Math.abs(minValue),Math.abs(maxValue));
    xm=Math.min(xm,maxValue-minValue);
    this.scale=Math.pow(10.0,Math.floor(Math.log(xm)/LOG10));
    this.scaleMin=this.scale*Math.floor(minValue/this.scale);
    if(this.scaleMin==minValue) this.scaleMin-=this.scale;
    this.scaleMax=this.scale*Math.ceil(maxValue/this.scale);
    if(this.scaleMax==maxValue) this.scaleMax+=this.scale;
  }
  this.setScaleLabel();
};

// Otڐxݒ肷
GraphAxis.prototype.setScaleLabel=function(){
  var count=parseInt((this.scaleMax-this.scaleMin)/this.scale)+1;
  this.scaleLabel.length=0;
  for(var i=0;i<count;i++){
    this.scaleLabel[i]=this.toLabel(this.scaleMin+this.scale*i);
  }
};

// Wݒ肷
// p0 ʒu
// range \͈
// direc @1F@-1F
GraphAxis.prototype.setCoef=function(p0,range,direc){
  this.coef1=direc*range/(this.scaleMax-this.scaleMin);
  this.coef0=p0-this.coef1*this.scaleMin;
};

// f[^`ʒuɕϊ
// x f[^
GraphAxis.prototype.toView=function(x){
  return parseInt(this.coef1*x+this.coef0);
};

// `ʒuf[^ɕϊ
// x `ʒu
GraphAxis.prototype.toData=function(x){
  return (x-this.coef0)/this.coef1;
};

// `悷
// x0,y0 - x,yW
// width - \
GraphAxis.prototype.drawHorizontal=function(x0,y0,width){
  context.beginPath();
  context.moveTo(x0,y0);
  context.lineTo(x0+width,y0);
  var ty=y0+1,metrix;
  for(var i=0;i<this.scaleLabel.length;i++){
    var x=this.fromScaleToView(this.scaleMin+this.scale*i);
    context.moveTo(x,y0);
    context.lineTo(x,y0-SCALE_SIZE);
    metrix=context.measureText(this.scaleLabel[i]);
    context.fillText(this.scaleLabel[i],parseInt(x-metrix.width/2),ty);
  }
  context.closePath();
  context.stroke();
  metrix=context.measureText(this.text);
  context.fillText(this.text,parseInt(x0+(width-metrix.width)/2),
      	      	   ty+FONT_SIZE);
};

// `悷
// x0,y0 - x,yW
// height - \
GraphAxis.prototype.drawVertical=function(x0,y0,height){
  context.beginPath();
  context.moveTo(x0,y0);
  context.lineTo(x0,y0+height);
  var dy=parseInt(FONT_SIZE/2)+2,metrix;
  for(var i=0;i<this.scaleLabel.length;i++){
    var y=this.fromScaleToView(this.scaleMin+this.scale*i);
    context.moveTo(x0,y);
    context.lineTo(x0+SCALE_SIZE,y);
    metrix=context.measureText(this.scaleLabel[i]);
    context.fillText(this.scaleLabel[i],x0-metrix.width-2,y-dy);
  }
  context.closePath();
  context.stroke();
  metrix=context.measureText(this.text);
  context.fillText(this.text,parseInt(x0-metrix.width/2),
      	      	   y0-FONT_SIZE-dy);
};

// ڐ̐l𕶎ɕϊ
// s ڐ̐l
GraphAxis.prototype.toLabel=function(s){
  return String(s);
};

// ڐ̐l`ʒuɕϊ
// s ڐ̐l
GraphAxis.prototype.fromScaleToView=function(s){
  return this.toView(s);
};

//--------------------------------------------------------------------//
// ΐOt
// text - x
var LogAxis=function(text){
  GraphAxis.call(this,text);
};

// Otڐݒ肷
// minValue,maxValue - f[^ŏlEől
LogAxis.prototype.setScale=function(minValue,maxValue){
  if(minValue>=maxValue){
    this.scaleMin=Math.floor(Math.log(maxValue)/LOG10);
    this.scaleMax=this.scaleMin+1;
    this.scale=1;
  }
  else{
    this.scaleMin=Math.floor(Math.log(minValue)/LOG10);
    this.scaleMax=Math.ceil(Math.log(maxValue)/LOG10);
    this.scale=Math.ceil((this.scaleMax-this.scaleMin)/4);
  }
  this.setScaleLabel();
};

// Wݒ肷
// p0 ʒu
// range \͈
// direc @1F@-1F
LogAxis.prototype.setCoef=function(p0,range,direc){
  this.coef1=direc*range/((this.scaleMax-this.scaleMin)*LOG10);
  this.coef0=p0-this.coef1*this.scaleMin*LOG10;
};

// f[^`ʒuɕϊ
// x f[^
LogAxis.prototype.toView=function(x){
  return parseInt(this.coef1*Math.log(x)+this.coef0);
};

// `ʒuf[^ɕϊ
// x `ʒu
LogAxis.prototype.toData=function(x){
  return Math.exp((x-this.coef0)/this.coef1);
};

// ڐ̐l𕶎ɕϊ
// s ڐ̐l
LogAxis.prototype.toLabel=function(s){
  return '10^'+parseInt(s);
};

// ڐ̐l`ʒuɕϊ
// s ڐ̐l
LogAxis.prototype.fromScaleToView=function(s){
  return this.toView(Math.pow(10,s));
};

inherits(StateVariable,VaporVariable);
inherits(LogAxis,GraphAxis);
